package OpenILS::DomainObjectCollection;
use base 'OpenILS::DOM::Element::domainObjectCollection';
use OpenILS::DOM;
use OpenILS::Utils::Logger qw(:level);
my $logger = "OpenILS::Utils::Logger";

=head1 NAME

OpenILS::DomainObjectCollection

=head1 SYNOPSIS

OpenILS::DomainObjectCollection is an abstract base class.  It
should not be used directly.  See C<OpenILS::DomainObjectCollection::*>
for details.

=cut

sub new {
	my $class = shift;
	$class = ref($class) || $class;

	my @args = shift;

	(my $type = $class) =~ s/^.+://o;

	my $doc = OpenILS::DOM->createDocument;
	my $dO = OpenILS::DOM::Element::domainObjectCollection->new( $type, @args );

	$doc->documentElement->appendChild($dO);

	return $dO;
}

1;
